;===============_vputs_ml by Donald Straney==============
;
;42 bytes/cycles dependent on string length
;Inputs: hl-Pointer to zero-terminated string, $d6 is
;        new line
;        _penRow-Starting row for text
;        _penCol-Starting column for text
;
;Outputs: text drawn to screen
;

_vputs_ml:
  push hl                       ;Save starting position of string
_v_inc_loop:
  ld a,(hl)                     ;Look at current char in string
  cp $d6                        ;Is $d6? (new line char)
  jr z,_v_replace_zero          ;If so, go to new line
  or a                          ;Is 0? (end-of-string char)
  jr z,_v_disp_end               ;If so, end routine
  inc hl                        ;Point to next char
  jr _v_inc_loop                 ;and loop
_v_replace_zero:
  ld (hl),0                     ;Replace newline char with end-of-string char
  ex de,hl                      ;Save current position
  pop hl                        ;and restore beginning-of-line pointer
  push de
  B_CALL(_VPutS)                ;Draw string
  pop de
  call _v_new_line              ;then go to new line
  ex de,hl                      ;Restore position in string at newline char
  ld (hl),$d6                   ;and restore the $d6
  inc hl                        ;and point to char after $d6
  push hl                       ;Save that as new beginning-of-line pointer
  jr _v_inc_loop                ;Go back to the loop
_v_disp_end:
  pop hl                        ;Remove beginning-of-line pointer from stack to prevent crash
  B_CALL(_VPutS)                ;and draw last line
  ret

_v_new_line:                    ;Move small cursor down 1 row
  ld bc,_penRow
  ld a,(bc)
  add a,6
  ld (bc),a
  xor a
  ld (_penCol),a
  ret